--- zaptel.c	2004-07-17 11:57:15.000000000 +0200
+++ zaptel.c	2004-07-21 16:03:37.000000000 +0200
@@ -1946,7 +1946,8 @@
 	chan->afterdialingtimer = 0;
 
 	chan->cadencepos = 0;
-	
+	chan->firstcadencepos = 0; /* By default loop back to first cadence position */
+
 	/* HDLC & FCS stuff */
 	fasthdlc_init(&chan->rxhdlc);
 	fasthdlc_init(&chan->txhdlc);
@@ -3663,10 +3664,26 @@
 			if (copy_from_user(&cad, (struct zt_ring_cadence *)data, sizeof(cad)))
 				return -EIO;
 			memcpy(chan->ringcadence, &cad, sizeof(chan->ringcadence));
+			chan->firstcadencepos = 0;
+			/* Looking for negative ringing time indicating where to loop back into ringcadence */
+			for (i=0; i<ZT_MAX_CADENCE; i+=2 )
+			        if (chan->ringcadence[i]<0) {
+				        chan->ringcadence[i] *= -1;
+					chan->firstcadencepos = i;
+					break;
+				}
 		} else {
 			/* Reset to default */
+			chan->firstcadencepos = 0;
 			if (chan->curzone) {
 				memcpy(chan->ringcadence, chan->curzone->ringcadence, sizeof(chan->ringcadence));
+				/* Looking for negative ringing time indicating where to loop back into ringcadence */
+				for (i=0; i<ZT_MAX_CADENCE; i+=2 )
+				        if (chan->ringcadence[i]<0) {
+				               chan->ringcadence[i] *= -1;
+					       chan->firstcadencepos = i;
+					       break;
+					}
 			} else {
 				memset(chan->ringcadence, 0, sizeof(chan->ringcadence));
 				chan->ringcadence[0] = chan->starttime;
@@ -4761,11 +4778,11 @@
 		/* Turn on the ringer now that the silent time has passed */
 		++chan->cadencepos;
 		if (chan->cadencepos >= ZT_MAX_CADENCE)
-			chan->cadencepos = 0;
+			chan->cadencepos = chan->firstcadencepos;
 		len = chan->ringcadence[chan->cadencepos];
 
 		if (!len) {
-			chan->cadencepos = 0;
+			chan->cadencepos = chan->firstcadencepos;
 			len = chan->ringcadence[chan->cadencepos];
 		}
 
